def FAILED_STAGE
def Estado

script {
    Branch = "${branch}"
    DesString = "${devName}"
    Desarrollador = DesString.replace("_"," ").replace("ÃƒÂ±","n").replace("Ã±","n").replace("Ã‘","N").replace("ÃƒÂ±","N")
    CorreoDesarrollador = "${DevMail}"
    GrupoCorreoArea = "${mailGroup}"
    LigaGitlab = "${repositoryGit}"
    VUE_DIR="Front\\frq-plataforma-franquicia-app\\src\\main\\vue-src"
    Uniquifier = UUID.randomUUID().toString()
}
pipeline {
    environment {
        BRANCH_NAME =  "${GIT_BRANCH.split("/")[1]}"
    }
    agent any
    stages {
        stage ('DevOpsConfig') {
            steps {
                script {
                    FAILED_STAGE=env.STAGE_NAME
                }
                echo "Building... ${BRANCH_NAME}"  
            }
        }
        /*stage ('Build Vue') {
            steps {
                script { 
                    FAILED_STAGE = env.STAGE_NAME
                }
                dir(VUE_DIR) {
                    nodejs(configId: '75f913f1-f718-4ced-9cf1-ca0014b58b04', nodeJSInstallationName: 'Node Last') {
                        sh "npm install"
                        sh "npm run build"
                    }
                }
            }
        }
        stage ('Build') {
            steps {
                script { 
                    FAILED_STAGE = env.STAGE_NAME
                }
                withMaven(globalMavenSettingsConfig: '4d106d46-84a2-4961-920d-b89de674b140', jdk: 'jdk8', maven: 'Maven3', mavenSettingsConfig: '94c7d298-fc73-4d15-941e-9cdf572d9c8d') {
                    sh "mvn clean install"
                }
            }
        }
        stage ('GettingBasicInfo') {
            steps {
                script {
                    FAILED_STAGE = env.STAGE_NAME
                    info = readProperties  file: 'Front\\frq-plataforma-franquicia-app\\target\\classes\\build.properties'
                    projectName = info['nameApp']
                    projectVersion = info['git.closest.tag.name']
                }
            }
        }
        stage('Dockerizando') {
            steps {
                script {
                    FAILED_STAGE = STAGE_NAME
                    sshPublisher(
                        continueOnError: false,
                        failOnError: true,
                        publishers: [
                            sshPublisherDesc(
                                configName: 'Docker56',
                                transfers: [
                                    sshTransfer(
                                        cleanRemote: false,
                                        excludes: '',
                                        execTimeout: 1200000,
                                        flatten: false,
                                        makeEmptyDirs: false,
                                        noDefaultExcludes: false,
                                        patternSeparator: '[, ]+',
                                        remoteDirectory: '',
                                        remoteDirectorySDF: false,
                                        removePrefix: '',
                                        sourceFiles: '',
                                        execCommand: """
                                            (rm -rf tmp/${projectName}-* || true) && \\
                                            mkdir tmp/${projectName}-${Uniquifier}
                                        """
                                    ),
                                    sshTransfer(
                                        cleanRemote: false,
                                        excludes: '',
                                        execTimeout: 1200000,
                                        flatten: false,
                                        makeEmptyDirs: false,
                                        noDefaultExcludes: false,
                                        patternSeparator: '[, ]+',
                                        remoteDirectory: "tmp/${projectName}-${Uniquifier}",
                                        remoteDirectorySDF: false,
                                        removePrefix: '',*/
                                        //sourceFiles: 'Front/*/resources/**, Front/**/target/*.war, Dockerfile',
                                        /*execCommand: """
                                            cd tmp/${projectName}-${Uniquifier} && \\
                                            ls -lh && \\
                                            docker -v && \\
                                            docker build --tag ${projectName}:${projectVersion} . && \\
                                            ls -lh 
                                        """
                                    ),
                                    sshTransfer(
                                        cleanRemote: false,
                                        excludes: '',
                                        execTimeout: 1200000,
                                        flatten: false,
                                        makeEmptyDirs: false,
                                        noDefaultExcludes: false,
                                        patternSeparator: '[, ]+',
                                        remoteDirectory: '',
                                        remoteDirectorySDF: false,
                                        removePrefix: '',
                                        sourceFiles: '',
                                        execCommand: "(rm -rf tmp/${projectName}-* || true)"
                                    )
                                ],
                                usePromotionTimestamp: false,
                                useWorkspaceInPromotion: false,
                                verbose: true
                            )
                        ]
                    )
                }
            }
        }
        stage('Deploy') {
            steps {
                script {
                    FAILED_STAGE = STAGE_NAME
                }
                build job: 
                    'frq-deploy-docker-local', 
                    parameters: [
                        string(name: 'image', value: "${projectName}:${projectVersion}"), 
                        string(name: 'container_name', value: "${projectName}"), 
                        text(name: 'app_port', value: '8081'), 
                        text(name: 'console_app_port', value: '9901'), 
                        text(name: 'volume_franquicia', value: '/franquicia'), 
                        string(name: 'volume_logs', value: '/logs')
                    ]
                echo "Deploying"
            }
        }
        stage('Upload'){
            steps{
                script {
                    FAILED_STAGE = STAGE_NAME
                    sshPublisher(
                        publishers: [
                            sshPublisherDesc(
                                configName: 'Developing-47-SFTP', 
                                transfers: [
                                    sshTransfer(
                                        cleanRemote: false, 
                                        excludes: '', 
                                        execCommand: '', 
                                        execTimeout: 120000, 
                                        flatten: false, 
                                        makeEmptyDirs: false, 
                                        noDefaultExcludes: false, 
                                        patternSeparator: '[, ]+', 
                                        remoteDirectory: '/home/sunone/WARS/PlataformaFranquicia', 
                                        remoteDirectorySDF: false, 
                                        removePrefix: 'Front/frq-plataforma-franquicia-app/target', 
                                        sourceFiles: 'Front/frq-plataforma-franquicia-app/target/plataforma-franquicia-app.war'
                                    )
                                ], 
                                usePromotionTimestamp: false, 
                                useWorkspaceInPromotion: false, 
                                verbose: false
                            )
                        ]
                    )
                }
                echo "Upload to SFTP 47"
            }
        }*/
    }
    post {
        failure {
            script {
                Estado = "Fallido"
            }
            emailext attachLog: true, body: 'Please read the attached log for more details...', recipientProviders: [buildUser(), brokenBuildSuspects()], subject: "Pipeline ${JOB_NAME} - ${BUILD_NUMBER} state fail on stage ${FAILED_STAGE}" 
        }
        success{
            script {
                Estado = "Exito"
            }
            emailext body: '<h1>¡Congratulations!</h1> <br> The current build compiled with success status, if you want launch the deployment go to <a href="www.google.com">application</a>', recipientProviders: [buildUser(), brokenBuildSuspects()], subject: "Pipeline ${JOB_NAME} - ${BUILD_NUMBER} state success"
        }
    }
}
